#################################################################################
# Nombre del programa:	ESOC2022_IMPORTAR_DATA.R                                          
# Autor:              	IECA
# Versión:            	1.0
# Última modificaciÓn: 	03 Octubre 2022
#                                                                                
# Descripción: 
#	Este programa procesa un fichero de microdatos (md_ESOC2022.dat)
#
# Entrada:                                                           
#     - Archivo de microdatos: 	md_ESOC2022.dat
# Salida: 
#     - Archivo de microdatos en formato data.frame de R: md_ESOC2022
#                                                                                
#################################################################################

####################    Asignación de parámetros    #######################
#Recogemos la ruta del script en la que se encuentra el fichero de microdatos

setwd("C:/Microdatos_ESOC2022_ASCII")
fichero_micro <- "md_ESOC2022.dat"

#################################################################################

assign("flag_num", 0, envir = .GlobalEnv)

atencion = function(mensaje){
  cat(mensaje)
  assign("flag_num", 1, envir = .GlobalEnv)
  
}

####################     INICIO     #########################
start.time <- Sys.time()
cat("\n")
cat("\n Inicio: ")
print.Date(start.time)
t0 <- proc.time()

nombresVarbls <- c("idp","fep","grurba","fdom","tipviv","cpro","sexo","edad","nacionalidad","feliz1","feliz2","feliz3","feliz4",
                   "feliz5","feliz6","feliz7","feliz8","feliz9","feliz10","np","npcara","cont1","cont2","cont3","cont4",
                   "precont1","precont2","precont3","precont4","frec1","frec2","frec3","frec4","relacion","miedo","afirm1",
                   "afirm2","ncaract1","ncaract2","ncaract3","ncaract4","ncaract5","ncaract6","ncaract7","nbarrio","vecin",
                   "fvecin","vfavor","nvecin","segura","confi","ayuda1","ayuda2","ayuda3","ayuda4","ayuda5","ayuda6","nnueva",
                   "cmedio","opinion","asoc1","asoc2","asoc3","asoc4","asoc5","asoc6","asoc7","asoc8","asoc9","asoc10","asoc11",
                   "asoc12","particip","volunt","postactiv1","postactiv2","postactiv3","postactiv4","postactiv5","postactiv6",
                   "preactiv1","preactiv2","preactiv3","preactiv4","preactiv5","preactiv6","tipoh","menor","nestu","sactual","cno","ing")



posiciones    <-c(4,15,1,1,1,2,1,2,1,1,1,
                  1,1,1,1,1,1,1,1,2,2,2,
                  2,2,2,2,2,2,2,1,1,1,1,
                  1,1,2,2,2,2,2,2,2,2,2,
                  1,2,1,1,1,1,2,2,2,2,2,
                  2,2,2,2,1,2,2,2,2,2,2,
                  2,2,2,2,2,2,2,1,2,2,2,
                  2,2,2,2,2,2,2,2,2,1,2,
                  2,2,2,2)


tipo          <- c("N","N","A","A","A","A","A","N","A","A","A","A",
                   "A","A","A","A","A","A","A","A","A","A","A","A",
                   "A","A","A","A","A","A","A","A","A","A","A","A",
                   "A","A","A","A","A","A","A","A","A","A","A","A",
                   "A","A","A","A","A","A","A","A","A","A","A","A",
                   "A","A","A","A","A","A","A","A","A","A","A","A",
                   "A","A","A","A","A","A","A","A","A","A","A","A",
                   "A","A","A","A","A","A","A","A")
                   
  

  

tamanio       <- length(nombresVarbls)


# Lectura del fichero de microdatos (MICROD)

  #Capturamos las columnas con su tipo de dato
  tipDatos <- as.vector(sapply(tipo, function(x){
    if(identical(x, "A"))
      "character"
    else{
      if(identical(x, "N"))
        "numeric"
    }
  }
  )
  )
  # Lectura del fichero de microdatos (MICROD), decimales con coma  
  tryCatch((df1 <- read.fwf(file = fichero_micro, widths= posiciones, colClasses=tipDatos)), error=function(e)
    stop(paste("Error. No se encuentra el fichero: ", e, fichero_micro,". Saliendo de la ejecuciÃ³n...", sep = "")))
  
#Aplicamos los nombres de la cabecera del registro

names(df1) <- nombresVarbls
df1$fep=df1$fep/100000000000
md_ESOC2022 <- df1






#Liberacion de memoria y aclaraciÃ³n de variables 
#Values
rm(flag_num,nombresVarbls,posiciones,tamanio,df1)
rm(tipDatos)


# Mensaje final ##########################################
end.time <- Sys.time()
cat("\n")
cat("\n Fin del proceso de lectura: ")
print.Date(end.time)

TTotal <- proc.time() - t0
tiempo <- TTotal[3]

if(tiempo < 60){
  cat(paste("\n Tiempo transcurrido:", format(round(tiempo, 2), nsmall = 2), "segundos"))
}else{
  if(tiempo< 3600 & tiempo >= 60){
    cat(paste("\n Tiempo transcurrido:", format(round(tiempo/60, 2), nsmall = 2), "minutos"))
  }else{
    cat(paste("\n Tiempo transcurrido:", format(round(tiempo/3600, 2), nsmall = 2), "horas"))
  }
}
